Attribute VB_Name = "ModSpline"
'//////////////////////////////////////
'Truevision 3D Simple Spline Sample
'----------------------------------
'Based On The Gravity Cam. Sample (Sample 17)
'Spline Sample By: Megazoid
'----------------------------------
'Thanks to Sylvain and Sigurd (Gabitasoft)
'For Making a Great Engine!
'//////////////////////////////////////

Option Explicit

'////////////////////////////////////////
Public Truevision        As New TrueVision8
Public Scene             As New Scene8
Public Land              As New Landscape8
Public Inp               As New InputEngine8
Public Scr               As New Screen8
Public TexFactory        As New TextureFactory8
Public Effects           As New GraphicEffect8
'////////////////////////////////////////

'////////////////////////////////////////
Public Camera            As New Camera8
Public GCamera(2)        As CameraGravity
Public sTime             As Single
Public Path              As New Path8
'////////////////////////////////////////

'////////////////////////////////////////
Dim Width As Long, Height As Long
'////////////////////////////////////////

Private Sub Main()
    
    '///////////////////////////////////////
    Path.AddPathNode Vector(700, 90, 900)
    Path.AddPathNode Vector(1387.253, 180, 1002.404)
    Path.AddPathNode Vector(1369.484, 119.2096, 1536)
    Path.AddPathNode Vector(1284.13, 106.556, 1838.44)
    Path.AddPathNode Vector(1086.679, 170, 1674.464)
    '///////////////////////////////////////

    '///////////////////////////////////////
    If Truevision.ShowDriverDialog = False Then Exit Sub
    Truevision.Initialize
    Truevision.Console = False
    Set Inp = New InputEngine8
    Truevision.DisplayFPS = True
    Truevision.SetSearchDirectory App.Path
    '///////////////////////////////////////

    '///////////////////////////////////////
    TexFactory.LoadTexture "cloudx.dds", "Cloud1", , , TV_COLORKEY_BLACK
    TexFactory.LoadTexture "cloudx.dds", "Cloudx", , , TV_COLORKEY_BLACK
    TexFactory.LoadTexture "map_farview.jpg", "Terrain"
    TexFactory.LoadTexture "sun.jpg", "sun"
    TexFactory.LoadTexture "water.bmp", "water"
    TexFactory.LoadTexture "detail.jpg", "detail"
    TexFactory.LoadTexture "Back.jpg", "Front"
    TexFactory.LoadTexture "Front.jpg", "Back"
    TexFactory.LoadTexture "Left.jpg", "Right"
    TexFactory.LoadTexture "Right.jpg", "Left"
    TexFactory.LoadTexture "down.jpg", "Down"
    TexFactory.LoadTexture "top.jpg", "Top"
    TexFactory.LoadTexture "loading.jpg", "Loading"
    TexFactory.LoadTexture "logo.jpg", "Logo"
    '///////////////////////////////////////
    
    '///////////////////////////////////////
    Truevision.GetVideoMode Width, Height, 0
    Truevision.Clear
    '///////////////////////////////////////

    '///////////////////////////////////////
    Scr.DrawTexture GetTex("Loading"), Width / 2 - 150, Height / 2 - 50, Width / 2 + 250, Height / 2 + 50
    Scr.DrawTexture GetTex("Logo"), Width / 2 - 320, Height / 2 - 100, Width / 2 - 175, Height / 2 + 100
    Truevision.RenderToScreen
    '///////////////////////////////////////
    
    '///////////////////////////////////////
    Scene.EnableMipMapping True
    Scene.SetDithering True
    Scene.SetSceneBackGround 0.4, 0.6, 0.9
    Scene.SetViewFrustum 90, 100000
    '///////////////////////////////////////

    Effects.FadeIn 7000
        
    '///////////////////////////////////////
    Land.GenerateHugeTerrain "myland.jpg", TV_PRECISION_LOW, 10, 10, 0, 0, True
    Land.EnableLOD True
    Land.SetWaterTexture GetTex("water")
    Land.SetWaterEffect True, 1, True, D3DBLEND_ONE, , True
    Land.SetWaterTextureScale 86
    Land.SetWaterAltitude 86
    Land.SetWaterEnable True
    '///////////////////////////////////////
    
    '///////////////////////////////////////
    Land.InitSun GetTex("Sun"), Vector(-1000, 500, 0), 2
    Land.SetTexture GetTex("Terrain")
    Land.SetTextureScale 1, 1
    Land.ExpandTexture GetTex("Terrain"), 0, 0, 10, 10
    Land.SetDetailTexture GetTex("detail")
    Land.SetDetailTextureScale 15, 15
    '///////////////////////////////////////

    '///////////////////////////////////////
    Scene.SetSkyTexture GetTex("Front"), GetTex("Back"), GetTex("Left"), GetTex("Right"), GetTex("Top"), GetTex("Down"), 1500
    '///////////////////////////////////////
    
    GCamera(0).x = 700
    GCamera(0).z = 900
    
    Do
      
      Truevision.Clear
      Scene.RenderSky
      Scene.RenderAllMeshes
      Land.Render False
        
      sTime = sTime + Truevision.TimeElapsed * 0.0002
      Path.CameraSpline sTime, 1
            
      Truevision.RenderToScreen
    
    DoEvents
        
    Loop Until Inp.IsKeyPressed(TV_KEY_ESCAPE)
    Set Truevision = Nothing

End Sub

